程序師世界是廣大編程愛好者互助、分享、學習的平台,程序師世界有你更精彩!
首頁
編程語言
C語言|JAVA編程
Python編程
網頁編程
ASP編程|PHP編程
JSP編程
數據庫知識
MYSQL數據庫|SqlServer數據庫
Oracle數據庫|DB2數據庫
 程式師世界 >> 編程語言 >> C語言 >> C++ >> C++入門知識 >> hdu 1350 Taxi Cab Scheme(二分匹配)

hdu 1350 Taxi Cab Scheme(二分匹配)

編輯:C++入門知識

hdu 1350 Taxi Cab Scheme(二分匹配)


 

 

Taxi Cab Scheme

Time Limit: 20000/10000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 943 Accepted Submission(s): 456

Problem Description Running a taxi station is not all that simple. Apart from the obvious demand for a centralised coordination of the cabs in order to pick up the customers calling to get a cab as soon as possible, there is also a need to schedule all the taxi rides which have been booked in advance. Given a list of all booked taxi rides for the next day, you want to minimise the number of cabs needed to carry out all of the rides.

For the sake of simplicity, we model a city as a rectangular grid. An address in the city is denoted by two integers: the street and avenue number. The time needed to get from the address a, b to c, d by taxi is |a - c| + |b - d| minutes. A cab may carry out a booked ride if it is its first ride of the day, or if it can get to the source address of the new ride from its latest, at least one minute before the new ride’s scheduled departure. Note that some rides may end after midnight.

Input On the first line of the input is a single positive integer N, telling the number of test scenarios to follow. Each scenario begins with a line containing an integer M, 0 < M < 500, being the number of booked taxi rides. The following M lines contain the rides. Each ride is described by a departure time on the format hh:mm (ranging from 00:00 to 23:59), two integers a b that are the coordinates of the source address and two integers c d that are the coordinates of the destination address. All coordinates are at least 0 and strictly smaller than 200. The booked rides in each scenario are sorted in order of increasing departure time.

Output For each scenario, output one line containing the minimum number of cabs required to carry out all the booked taxi rides.

Sample Input
2
2
08:00 10 11 9 16
08:07 9 16 10 11
2
08:00 10 11 9 16
08:06 9 16 10 11

Sample Output
1
2

Source Northwestern Europe 2004
Recommend JGShining | We have carefully selected several similar problems for you: 1054 1083 1528 1287 1507 題目大意:直白一點講解第一組數據:先輸入一個n,表示有幾個人要乘車,接下去n行,每一行輸入的是:時間、起始位置坐標、目標位置坐標

 

按照上述所給的數據及要求,輸出最少所需要的司機數量。

解題思路:開始看到這道題目第一想法就是貪心,直接拿到達目標位置時間和下一個人的起始時間比較。但是做下去發現不能夠得到最少的司機數量。這題我們應該采用二分匹配的最少邊覆蓋,最小路徑覆蓋= -最大匹配數(n為定點數)

具體實現:將每一個人的坐標看成一個點。如果第一位司機接到a顧客後接到b,就將a,b連成一條有向邊。並且要最少的司機覆蓋所有點。完美的轉化~~~

特別注意:

1、送乘客的時間為曼哈距離,公式為 |a - c| + |b - d|

2、每換乘一次需要間隔一分鐘,所以不要忘記加1

 

詳見代碼。

 

#include 
#include 
#include 

using namespace std;

struct node
{
    int stime,etime,sx,sy,ex,ey;
} p[510];

int Map[510][510];
int n;
int ok[510],vis[510];

int fun(int a)
{
    return a<0?-a:a;
}

bool Find(int x)
{
    for (int i=0; i

 

 

  1. 上一頁:
  2. 下一頁:
Copyright © 程式師世界 All Rights Reserved